Loading...
Searching...
No Matches
binary.c File Reference

Built-in binary type plugin. More...

`#include "plugins_types.h"`
`#include <ctype.h>`
`#include <stdint.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "libyang.h"`
`#include "compat.h"`
`#include "ly_common.h"`
`#include "plugins_internal.h"`
Include dependency graph for binary.c:

Go to the source code of this file.

## Macros

#define | _GNU_SOURCE /* strdup */

## Functions

LIBYANG_API_DEF LY_ERR | lyplg_type_compare_binary (const struct ly_ctx *UNUSED(ctx), const struct lyd_value *val1, const struct lyd_value *val2)
LIBYANG_API_DEF LY_ERR | lyplg_type_dup_binary (const struct ly_ctx *ctx, const struct lyd_value *original, struct lyd_value *dup)
| Implementation of lyplg_type_dup_clb for the built-in binary type.
LIBYANG_API_DEF void | lyplg_type_free_binary (const struct ly_ctx *ctx, struct lyd_value *value)
| Implementation of lyplg_type_free_clb for the built-in binary type.
LIBYANG_API_DEF const void * | lyplg_type_print_binary (const struct ly_ctx *ctx, const struct lyd_value *value, LY_VALUE_FORMAT format, void *UNUSED(prefix_data), ly_bool *dynamic, size_t *value_len)
LIBYANG_API_DEF int | lyplg_type_sort_binary (const struct ly_ctx *UNUSED(ctx), const struct lyd_value *val1, const struct lyd_value *val2)
LIBYANG_API_DEF LY_ERR | lyplg_type_store_binary (const struct ly_ctx *ctx, const struct lysc_type *type, const void *value, size_t value_len, uint32_t options, LY_VALUE_FORMAT format, void *UNUSED(prefix_data), uint32_t hints, const struct lysc_node *UNUSED(ctx_node), struct lyd_value *storage, struct lys_glob_unres *UNUSED(unres), struct ly_err_item **err)

## Variables

const struct lyplg_type_record | plugins_binary []
| Plugin information for binray type implementation.

## Detailed Description

Built-in binary type plugin.

Author
  Radek Krejci rkrej.nosp@m.ci@c.nosp@m.esnet.nosp@m..cz

Copyright (c) 2019-2021 CESNET, z.s.p.o.

This source code is licensed under BSD 3-Clause License (the "License"). You may not use this file except in compliance with the License. You may obtain a copy of the License at

    https://opensource.org/licenses/BSD-3-Clause

Definition in file binary.c.

## Macro Definition Documentation

## _GNU_SOURCE

#define _GNU_SOURCE /* strdup */

Definition at line 15 of file binary.c.

## Function Documentation

## lyplg_type_compare_binary()

LIBYANG_API_DEF LY_ERR lyplg_type_compare_binary | ( | const struct ly_ctx * | UNUSEDctx,
|  | const struct lyd_value * | val1,
|  | const struct lyd_value * | val2 )

Definition at line 368 of file binary.c.

## lyplg_type_print_binary()

LIBYANG_API_DEF const void * lyplg_type_print_binary | ( | const struct ly_ctx * | ctx,
|  | const struct lyd_value * | value,
|  | LY_VALUE_FORMAT | format,
|  | void * | UNUSEDprefix_data,
|  | ly_bool * | dynamic,
|  | size_t * | value_len )

Definition at line 402 of file binary.c.

## lyplg_type_sort_binary()

LIBYANG_API_DEF int lyplg_type_sort_binary | ( | const struct ly_ctx * | UNUSEDctx,
|  | const struct lyd_value * | val1,
|  | const struct lyd_value * | val2 )

Definition at line 382 of file binary.c.

## lyplg_type_store_binary()

LIBYANG_API_DEF LY_ERR lyplg_type_store_binary | ( | const struct ly_ctx * | ctx,
|  | const struct lysc_type * | type,
|  | const void * | value,
|  | size_t | value_len,
|  | uint32_t | options,
|  | LY_VALUE_FORMAT | format,
|  | void * | UNUSEDprefix_data,
|  | uint32_t | hints,
|  | const struct lysc_node * | UNUSEDctx_node,
|  | struct lyd_value * | storage,
|  | struct lys_glob_unres * | UNUSEDunres,
|  | struct ly_err_item ** | err )

< Value was dynamically allocated in its exact size and is supposed to be freed or directly inserted into the context's dictionary (e.g. in case of canonization). In any case, the caller of the callback does not free the provided value after calling the type's store callback with this option.

< Value was dynamically allocated in its exact size and is supposed to be freed or directly inserted into the context's dictionary (e.g. in case of canonization). In any case, the caller of the callback does not free the provided value after calling the type's store callback with this option.

< Value was dynamically allocated in its exact size and is supposed to be freed or directly inserted into the context's dictionary (e.g. in case of canonization). In any case, the caller of the callback does not free the provided value after calling the type's store callback with this option.

< Value was dynamically allocated in its exact size and is supposed to be freed or directly inserted into the context's dictionary (e.g. in case of canonization). In any case, the caller of the callback does not free the provided value after calling the type's store callback with this option.

< The value is stored only, type-specific validation is skipped (performed before)

< Value was dynamically allocated in its exact size and is supposed to be freed or directly inserted into the context's dictionary (e.g. in case of canonization). In any case, the caller of the callback does not free the provided value after calling the type's store callback with this option.

Definition at line 257 of file binary.c.

## Variable Documentation

## plugins_binary

const struct lyplg_type_record plugins_binary[]

Initial value:
= {
{
.module = "",
.revision = NULL,
.name = LY_TYPE_BINARY_STR,
.plugin.id = "libyang 2 - binary, version 1",
.plugin.store = lyplg_type_store_binary,
.plugin.validate = lyplg_type_validate_binary,
.plugin.compare = lyplg_type_compare_binary,
.plugin.sort = lyplg_type_sort_binary,
.plugin.print = lyplg_type_print_binary,
.plugin.duplicate = lyplg_type_dup_binary,
.plugin.free = lyplg_type_free_binary,
.plugin.lyb_data_len = -1,
},
{0}
}
lyplg_type_print_binary
LIBYANG_API_DECL const void * lyplg_type_print_binary(const struct ly_ctx *ctx, const struct lyd_value *value, LY_VALUE_FORMAT format, void *prefix_data, ly_bool *dynamic, size_t *value_len)
Implementation of lyplg_type_print_clb for the built-in binary type.
lyplg_type_free_binary
LIBYANG_API_DECL void lyplg_type_free_binary(const struct ly_ctx *ctx, struct lyd_value *value)
Implementation of lyplg_type_free_clb for the built-in binary type.
Definition binary.c:474
lyplg_type_dup_binary
LIBYANG_API_DECL LY_ERR lyplg_type_dup_binary(const struct ly_ctx *ctx, const struct lyd_value *original, struct lyd_value *dup)
Implementation of lyplg_type_dup_clb for the built-in binary type.
Definition binary.c:444
lyplg_type_compare_binary
LIBYANG_API_DECL LY_ERR lyplg_type_compare_binary(const struct ly_ctx *ctx, const struct lyd_value *val1, const struct lyd_value *val2)
Implementation of lyplg_type_compare_clb for the built-in binary type.
lyplg_type_store_binary
LIBYANG_API_DECL LY_ERR lyplg_type_store_binary(const struct ly_ctx *ctx, const struct lysc_type *type, const void *value, size_t value_len, uint32_t options, LY_VALUE_FORMAT format, void *prefix_data, uint32_t hints, const struct lysc_node *ctx_node, struct lyd_value *storage, struct lys_glob_unres *unres, struct ly_err_item **err)
Implementation of lyplg_type_store_clb for the built-in binary type.
lyplg_type_sort_binary
LIBYANG_API_DECL int lyplg_type_sort_binary(const struct ly_ctx *ctx, const struct lyd_value *val1, const struct lyd_value *val2)
Implementation of lyplg_type_sort_clb for the built-in binary type.

Plugin information for binray type implementation.

Note that external plugins are supposed to use:

LYPLG_TYPES = {

Definition at line 494 of file binary.c.